package com.test.demo.modelo;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="FIlm")

public class FIlm {

public long getFilm_id() {
		return film_id;
	}
	public void setFilm_id(long film_id) {
		this.film_id = film_id;
	}
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
@Id
@Column(name="film_id")
private long film_id;
@Column(name="title")
private String title;
@Column(name="description")
private String description;

@ManyToOne(cascade = CascadeType.ALL)
@JoinColumn(name="language_id",referencedColumnName = "language_id")
private Language lang ;


@ManyToMany(cascade = CascadeType.ALL)

@JoinTable(name="film_actor",
				joinColumns = {@JoinColumn (name="film_id")},
				inverseJoinColumns = {@JoinColumn(name="actor_id")})

private List<Actor> actor;
public Language getLang() {
	return lang;
}
public void setLang(Language lang) {
	this.lang = lang;
}
public List<Actor> getActor() {
	return actor;
}
public void setActor(List<Actor> actor) {
	this.actor = actor;
}



}
